package ink.wgink.interfaces.department;

import ink.wgink.exceptions.base.SystemException;

import java.util.List;

/**
 * @ClassName: IDepartmentDeleteAfterHandler
 * @Description: 部门删除后操作
 * @Author: wanggeng
 * @Date: 2022/1/26 12:14 PM
 * @Version: 1.0
 */
public interface IDepartmentDeleteAfterHandler {

    /**
     * 操作
     *
     * @param departmentIds 部门ID列表
     * @throws SystemException
     */
    void handle(List<String> departmentIds) throws SystemException;

}
