package ink.wgink.interfaces.department;

import ink.wgink.exceptions.SearchException;

import java.util.List;

/**
 * @ClassName: IDepartmentUserDeleteAfterHandler
 * @Description: 部门用户删除后操作
 * @Author: wanggeng
 * @Date: 2022/1/26 3:21 PM
 * @Version: 1.0
 */
public interface IDepartmentUserDeleteAfterHandler {

    /**
     * 操作
     *
     * @param departmentId 部门ID
     * @param userIds      用户ID列表
     * @throws SearchException
     */
    void handle(String departmentId, List<String> userIds) throws SearchException;

}
