package ink.wgink.interfaces.department;

import ink.wgink.exceptions.base.SystemException;

import java.util.List;

/**
 * @ClassName: IDepartmentUserSaveAfterHandler
 * @Description: 部门用户新增后操作
 * @Author: wanggeng
 * @Date: 2022/1/26 3:20 PM
 * @Version: 1.0
 */
public interface IDepartmentUserSaveAfterHandler {

    /**
     * 操作
     *
     * @param departmentId 部门ID
     * @param userIds      用户ID列表
     * @throws SystemException
     */
    void handle(String departmentId, List<String> userIds) throws SystemException;

}
