package ink.wgink.interfaces.map;

import ink.wgink.exceptions.base.SystemException;

import java.util.List;

/**
 * @ClassName: IGridDeleteAfterHandler
 * @Description: 网格删除后处理
 * @Author: wanggeng
 * @Date: 2021/12/23 10:28 AM
 * @Version: 1.0
 */
public interface IGridDeleteAfterHandler {

    /**
     * 操作
     *
     * @param gridIds 网格ID列表
     * @throws SystemException
     */
    void handler(List<String> gridIds) throws SystemException;

}
