package ink.wgink.interfaces.map;

import ink.wgink.exceptions.base.SystemException;

import java.util.List;

/**
 * @ClassName: IGridPointRemoveAfterHandler
 * @Description: 网格点删除
 * @Author: wanggeng
 * @Date: 2021/12/23 10:37 AM
 * @Version: 1.0
 */
public interface IGridPointDeleteAfterHandler {

    /**
     * 操作
     *
     * @param gridIds 网格ID列表
     * @throws SystemException
     */
    void handle(List<String> gridIds) throws SystemException;

}
