package ink.wgink.interfaces.map;

import ink.wgink.exceptions.base.SystemException;

import java.util.List;

/**
 * @ClassName: IGridRelationDeleteAfterHandler
 * @Description: 网格关系删除操作
 * @Author: wanggeng
 * @Date: 2021/12/24 3:12 PM
 * @Version: 1.0
 */
public interface IGridRelationDeleteAfterHandler {

    /**
     * 操作
     *
     * @param relationIds 关联ID
     * @throws SystemException
     */
    void handle(List<String> relationIds) throws SystemException;

}
