package ink.wgink.interfaces.map;

import ink.wgink.exceptions.base.SystemException;
import ink.wgink.pojo.dtos.user.UserDTO;

import java.util.List;

/**
 * @ClassName: IGridMemberSaveHandler
 * @Description: 网格关系添加
 * @Author: wanggeng
 * @Date: 2021/12/24 2:59 PM
 * @Version: 1.0
 */
public interface IGridRelationSaveAfterHandler {

    /**
     * 操作
     *
     * @param relationIds 关系ID列表
     * @throws Exception
     */
    void handle(List<String> relationIds) throws SystemException;

    /**
     * 操作
     *
     * @param userDTO 用户
     * @throws Exception
     */
    void handle(UserDTO userDTO) throws SystemException;

}
