package ink.wgink.interfaces.map;

import ink.wgink.exceptions.base.SystemException;

/**
 * @ClassName: GridSaveAfterHandler
 * @Description: 网格新增后处理
 * @Author: wanggeng
 * @Date: 2021/12/23 10:25 AM
 * @Version: 1.0
 */
public interface IGridSaveAfterHandler {

    /**
     * 新增网格
     *
     * @param gridId    网格ID
     * @param gridCode  网格编码
     * @param gridName  网格名称
     * @param fillColor 填充颜色
     * @param areaCode  区域编码
     * @param areaName  区域名称
     * @throws SystemException
     */
    void handle(String gridId, String gridCode, String gridName, String fillColor, String areaCode, String areaName) throws SystemException;

}
