package ink.wgink.interfaces.map;

import ink.wgink.exceptions.base.SystemException;

/**
 * @ClassName: IGridUpdateAfterHandler
 * @Description: 网格更新后处理
 * @Author: wanggeng
 * @Date: 2021/12/23 10:26 AM
 * @Version: 1.0
 */
public interface IGridUpdateAfterHandler {

    /**
     * 修改网格
     *
     * @param gridId    网格ID
     * @param gridName  网格名称
     * @param fillColor 填充颜色
     * @throws SystemException
     */
    void handle(String gridId, String gridName, String fillColor) throws SystemException;

}
