package ink.wgink.interfaces.user;

import ink.wgink.exceptions.base.SystemException;

/**
 * @ClassName: IUserSaveAfterHandler
 * @Description: 用户新增后操作
 * @Author: wanggeng
 * @Date: 2022/1/26 12:15 PM
 * @Version: 1.0
 */
public interface IUserSaveAfterHandler {

    /**
     * 操作
     *
     * @param userId   用户ID
     * @param username 用户名
     * @param userName 用户昵称
     * @throws SystemException
     */
    void handle(String userId, String username, String userName) throws SystemException;

}
