package ink.wgink.properties;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

/**
 * @ClassName: LoggingProperties
 * @Description: 日志
 * @Author: wanggeng
 * @Date: 2021/10/23 12:03 上午
 * @Version: 1.0
 */
@Component
@ConfigurationProperties(prefix = "logging")
public class LoggingProperties {

    private Boolean enableApiLog;

    public Boolean getEnableApiLog() {
        return enableApiLog == null ? false : enableApiLog;
    }

    public void setEnableApiLog(Boolean enableApiLog) {
        this.enableApiLog = enableApiLog;
    }
}
