package ink.wgink.properties.map;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

/**
 * @ClassName: BaiduMapProperties
 * @Description: 百度地图配置
 * @Author: wanggeng
 * @Date: 2022/1/8 3:28 PM
 * @Version: 1.0
 */
@Component
@ConfigurationProperties(prefix = "map.baidu-map")
public class BaiduMapProperties extends MapProperties {

    /**
     * 边界
     */
    private String boundary;

    public String getBoundary() {
        return boundary == null ? "" : boundary.trim();
    }

    public void setBoundary(String boundary) {
        this.boundary = boundary;
    }
}
