package ink.wgink.properties.map;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

/**
 * @ClassName: SuperMapProperties
 * @Description: 超图配置
 * @Author: wanggeng
 * @Date: 2021/12/19 5:25 PM
 * @Version: 1.0
 */
@Component
@ConfigurationProperties(prefix = "map.super-map")
public class SuperMapProperties extends MapProperties {

    private String baseMapUrl;

    public String getBaseMapUrl() {
        return baseMapUrl == null ? "" : baseMapUrl.trim();
    }

    public void setBaseMapUrl(String baseMapUrl) {
        this.baseMapUrl = baseMapUrl;
    }
}
