package ink.wgink.login.oauth2.client.controller.route.department;

import ink.wgink.interfaces.consts.ISystemConstant;
import io.swagger.annotations.Api;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

/**
 * @ClassName: DepartmentRouteController
 * @Description: 部门接口
 * @Author: wanggeng
 * @Date: 2022/1/11 10:14 PM
 * @Version: 1.0
 */
@Api(tags = ISystemConstant.ROUTE_TAGS_PREFIX + "组织部门接口")
@Controller
@RequestMapping(ISystemConstant.ROUTE_PREFIX + "/department")
public class DepartmentRouteController {

    @GetMapping("list-tree-check")
    public ModelAndView selectUser() {
        return new ModelAndView("department/list-tree-check");
    }

}
