package ink.wgink.module.activiti.controller.route.oa;

import ink.wgink.common.base.DefaultBaseController;
import ink.wgink.interfaces.consts.ISystemConstant;
import io.swagger.annotations.Api;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

/**
 * @ClassName: OaController
 * @Description: Oa管理
 * @Author: wanggeng
 * @Date: 2022/3/23 09:54
 * @Version: 1.0
 */
@Api(tags = ISystemConstant.ROUTE_TAGS_PREFIX + "oa管理")
@Controller
    @RequestMapping(ISystemConstant.ROUTE_PREFIX + "/oa")
public class OaRouteController extends DefaultBaseController {

    @GetMapping("list-procdef")
    public ModelAndView listProcdef() {
        ModelAndView mv = new ModelAndView("oa/list-procdef");
        return mv;
    }

    @GetMapping("list-task-of-mine")
    public ModelAndView listTaskOfMine() {
        ModelAndView mv = new ModelAndView("oa/list-task-of-mine");
        return mv;
    }
    @GetMapping("list-history-task-of-mine")
    public ModelAndView listHistoryOfMine() {
        ModelAndView mv = new ModelAndView("oa/list-history-task-of-mine");
        return mv;
    }

    @GetMapping("list-process-log")
    public ModelAndView listLog() {
        ModelAndView mv = new ModelAndView("oa/list-process-log");
        return mv;
    }

}
