package ink.wgink.module.activiti.listener.task;

import ink.wgink.module.activiti.handler.IOaUserTaskCreateHandler;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.DelegateTask;
import org.activiti.engine.delegate.JavaDelegate;
import org.activiti.engine.delegate.TaskListener;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * @ClassName: OaUserTaskCreateListener
 * @Description: OA用户任务节点创建监听器
 * @Author: wanggeng
 * @Date: 2022/3/28 10:31
 * @Version: 1.0
 */
@Component
public class OaUserTaskCreateListener implements TaskListener, JavaDelegate {

    @Autowired(required = false)
    private IOaUserTaskCreateHandler oaUserTaskCreateHandler;

    @Override
    public void notify(DelegateTask delegateTask) {
        if (oaUserTaskCreateHandler != null) {
            oaUserTaskCreateHandler.handle(delegateTask);
        }
    }

    @Override
    public void execute(DelegateExecution execution) {
    }
}
