package ink.wgink.module.form.service.design;

import ink.wgink.module.form.pojo.vos.design.FormDesignVO;

import java.io.IOException;

/**
 * @Description: 表单设计
 * @Author: WenG
 * @Date: 2022/3/7 10:53
 * @Version: 1.0
 **/
public interface IFormDesignService {

    String FIELD_MAIN_TITLE = "MAIN_TITLE";
    String FIELD_ID = "id";
    String FIELD_UID = "uid";
    String FIELD_UIDS = "uids";
    String PROCESS_INSTANCE_ID = "process_instance_id";
    String FIELD_GMT_CREATE = "gmt_create";
    String FIELD_CREATOR = "creator";
    String FIELD_GMT_MODIFIED = "gmt_modified";
    String FIELD_MODIFIER = "modifier";
    String FIELD_IS_DELETE = "is_delete";
    String PARAM_FORM_CODE = "formCode";
    String PARAM_FORM_VERSION = "formVersion";
    String PARAM_QUERY_LIST = "queryList";
    String PARAM_LIST_SHOW_FIELD = "listShowField";
    String PARAM_PROCESS_INSTANCE_ID = "processInstanceId";
    String PARAM_INSERTS = "inserts";
    String PARAM_VALUES = "values";
    String PARAM_KV_LIST = "kvList";

    /**
     * 保存表单
     *
     * @param formDesignVO
     */
    void save(FormDesignVO formDesignVO) throws IOException;

}
