package ink.wgink.module.map.controller.route.grid;

import ink.wgink.interfaces.consts.ISystemConstant;
import io.swagger.annotations.Api;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

/**
 * @ClassName: GridUserRouteController
 * @Description: 网格用户路由
 * @Author: wanggeng
 * @Date: 2021/10/20 5:44 下午
 * @Version: 1.0
 */
@Api(tags = ISystemConstant.ROUTE_TAGS_PREFIX + "网格用户")
@Controller
@RequestMapping(ISystemConstant.ROUTE_PREFIX + "/grid/user")
public class GridUserRouteController {

    @GetMapping("list")
    public ModelAndView list() {
        return new ModelAndView("grid/grid/default/user/list");
    }

}
