package ink.wgink.module.map.controller.route.userlocation;

import ink.wgink.common.base.DefaultBaseController;
import ink.wgink.interfaces.consts.ISystemConstant;
import ink.wgink.module.map.service.userlocation.IUserLocationService;
import io.swagger.annotations.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * @ClassName: UserLocationController
 * @Description: 用户定位
 * @Author: CodeFactory
 * @Date: 2021-10-29 15:37:01
 * @Version: 3.0
 **/
@Api(tags = ISystemConstant.ROUTE_TAGS_PREFIX + "用户定位路由")
@RestController
@RequestMapping(ISystemConstant.ROUTE_PREFIX + "/user-location")
public class UserLocationRouteController extends DefaultBaseController {

    @GetMapping("save")
    public ModelAndView save() {
        return new ModelAndView("user-location/save");
    }

    @GetMapping("update")
    public ModelAndView update() {
        return new ModelAndView("user-location/update");
    }

    @GetMapping("list")
    public ModelAndView list() {
        return new ModelAndView("user-location/list");
    }

}