package ink.wgink.module.sms.pojo.vos.sms;

import ink.wgink.annotation.CheckEmptyAnnotation;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * @ClassName: SmsVO
 * @Description: 短信
 * @Author: WenG
 * @Date: 2020-03-14 16:01
 * @Version: 1.0
 **/
@ApiModel
public class SmsSendVO {

    @ApiModelProperty(name = "userIds", value = "用户ID列表（下划线分割）", required = true)
    @CheckEmptyAnnotation(name = "用户ID列表")
    private String userIds;
    @ApiModelProperty(name = "content", value = "发送内容", required = true)
    @CheckEmptyAnnotation(name = "发送内容")
    private String content;

    public String getUserIds() {
        return userIds == null ? "" : userIds.trim();
    }

    public void setUserIds(String userIds) {
        this.userIds = userIds;
    }

    public String getContent() {
        return content == null ? "" : content;
    }

    public void setContent(String content) {
        this.content = content;
    }

}
