package ink.wgink.service.position.service;

import ink.wgink.interfaces.position.IPositionBaseService;
import ink.wgink.interfaces.position.IPositionCheckService;
import ink.wgink.service.position.pojo.vos.PositionVO;

import java.util.List;

/**
 * @ClassName: IPositionService
 * @Description: 职位
 * @Author: admin
 * @Date: 2019-04-11 22:41:20
 * @Version: 1.0
 **/
public interface IPositionService extends IPositionBaseService, IPositionCheckService {

    /**
     * 新增职位
     *
     * @param positionVO
     * @return
     */
    void save(PositionVO positionVO);

    /**
     * 删除职位
     *
     * @param ids
     * @return
     */
    void remove(List<String> ids);

    /**
     * 修改职位
     *
     * @param positionId
     * @param positionVO
     * @return
     */
    void update(String positionId, PositionVO positionVO);
}
