package ink.wgink.interfaces.expand.register;

import java.util.Map;

/**
 * @ClassName: IRegisterWithExpandInfoHandlerService
 * @Description: 注册处理器，该接口在登录成功之后执行自定义的处理
 * @Author: wanggeng
 * @Version: 1.0
 */
public interface IRegisterWithExpandInfoHandlerService {

    /**
     * 注册处理
     *
     * @param userId        用户ID
     * @param expandInfo    拓展信息
     * @param requestParams 请求参数
     * @throws Exception
     */
    void handler(String userId, Map<String, Object> expandInfo, Map<String, Object> requestParams) throws Exception;

}
