package ink.wgink.interfaces.role;

import ink.wgink.exceptions.base.SystemException;

import java.util.List;

/**
 * @ClassName: IRoleUserSaveAfterHandler
 * @Description: 角色用户新增后操作
 * @Author: wanggeng
 * @Date: 2022/1/26 12:00 PM
 * @Version: 1.0
 */
public interface IRoleUserSaveAfterHandler {

    /**
     * 操作
     *
     * @param roleId  角色ID
     * @param userIds 用户ID列表
     * @throws SystemException
     */
    void handle(String roleId, List<String> userIds) throws SystemException;

}
