package ink.wgink.interfaces.user;

import ink.wgink.exceptions.base.SystemException;

/**
 * @ClassName: IUserUpdateAfterHandlerImpl
 * @Description: 用户修改后操作
 * @Author: wanggeng
 * @Date: 2021/12/24 3:50 PM
 * @Version: 1.0
 */
public interface IUserUpdateAfterHandler {

    /**
     * 修改后操作
     *
     * @param userId
     * @throws SystemException
     */
    void handle(String userId) throws SystemException;

}
