package ink.wgink.module.activiti.controller.route;

import ink.wgink.interfaces.consts.ISystemConstant;
import io.swagger.annotations.Api;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

/**
 * @ClassName: ActivitiProcdefRouteController
 * @Description: 流程定义
 * @Author: wanggeng
 * @Date: 2021/12/7 10:26 PM
 * @Version: 1.0
 */
@Api(tags = ISystemConstant.ROUTE_TAGS_PREFIX + "流程定义路由")
@Controller
@RequestMapping(ISystemConstant.ROUTE_PREFIX + "/activiti/procdef")
public class ActivitiProcdefRouteController {

    @GetMapping("list")
    public ModelAndView list() {
        ModelAndView mv = new ModelAndView("activiti/procdef/list");
        return mv;
    }

}
