package ink.wgink.module.activiti.pojo.vos.oa;

import ink.wgink.annotation.CheckNumberAnnotation;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * @Description: 显示状态
 * @Author: WenG
 * @Date: 2022/3/19 15:49
 * @Version: 1.0
 **/
@ApiModel
public class UpdateEditableVO {

    @ApiModelProperty(name = "isEditable", value = "是否可编辑")
    @CheckNumberAnnotation(name = "是否可编辑", types = {"0", "1"})
    private Integer isEditable;

    public Integer getIsEditable() {
        return isEditable == null ? 0 : isEditable;
    }

    public void setIsEditable(Integer isEditable) {
        this.isEditable = isEditable;
    }
}
