package ink.wgink.module.activiti.pojo.vos.oa;

import ink.wgink.annotation.CheckNumberAnnotation;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * @Description: 显示状态
 * @Author: WenG
 * @Date: 2022/3/19 15:49
 * @Version: 1.0
 **/
@ApiModel
public class UpdateVisibleVO {

    @ApiModelProperty(name = "isVisible", value = "是否可见")
    @CheckNumberAnnotation(name = "是否可见", types = {"0", "1"})
    private Integer isVisible;

    public Integer getIsVisible() {
        return isVisible == null ? 0 : isVisible;
    }

    public void setIsVisible(Integer isVisible) {
        this.isVisible = isVisible;
    }
}
