package ink.wgink.module.activiti.service.oa;

import ink.wgink.module.activiti.pojo.vos.ActivitiModelVO;

/**
 * @ClassName: INodeConfigService
 * @Description: 节点配置
 * @Author: wanggeng
 * @Date: 2022/4/5 20:27
 * @Version: 1.0
 */
public interface INodeManageService {

    /**
     * 保存管理配置
     *
     * @param activitiModelVO
     * @param modelId
     * @param modelVersion
     * @param deploymentId
     */
    void save(ActivitiModelVO activitiModelVO, String modelId, Integer modelVersion, String deploymentId);

    /**
     * 删除管理配置
     *
     * @param modelId
     * @param modelVersion
     */
    void delete(String modelId, Integer modelVersion);
}
