package ink.wgink.module.file.service.v2;

import ink.wgink.module.file.enums.UploadTypeEnum;
import ink.wgink.module.file.pojo.dtos.FileUploadSuccessDTO;
import org.springframework.web.multipart.MultipartFile;

import java.util.Map;

/**
 * @ClassName: IFileV2Service
 * @Description: 文件V2
 * @Author: wanggeng
 * @Date: 2022/4/13 16:15
 * @Version: 1.0
 */
public interface IFileV2Service {

    FileUploadSuccessDTO uploadSingle(MultipartFile uploadFile, UploadTypeEnum uploadTypeEnum, Map<String, Object> params);
}
