layui.define([], function (exports) {
    var lang = {
        id: '唯一标识',
        label: '标题',
        index: '序号',
        tag: '表单类型',
        tagIcon: '图标',
        width: '宽度',
        height: '高度',
        span: '网格宽度',
        placeholder: 'placeholder',
        defaultValue: '默认值',
        dateDefaultValue: '默认时间',
        labelWidth: '文本宽度',
        clearable: '是否清楚',
        prepend: '前缀',
        append: '追加',
        prefixIcon: '前缀图标',
        suffixIcon: '后缀图标',
        maxlength: '最大长度',
        showWordLimit: '是否限制字符',
        readonly: '只读',
        disabled: '禁用',
        required: '必填',
        columns: '列数',
        options: '选项',
        switchValue: '默认值',
        maxValue: '最大值',
        minValue: '最小值',
        dataMaxValue: '最大日期',
        dataMinValue: '最小日期',
        stepValue: '步长',
        datetype: '日期类型',
        dateformat: '日期格式',
        half: '显示半星',
        theme: '皮肤',
        rateLength: '星星个数',
        interval: '间隔毫秒',
        startIndex: '开始位置',
        full: '是否全屏',
        arrow: '鼠标样式',
        contents: '内容',
        document: '帮助文档',
        input: '输入框',
        select: '下拉',
        checkbox: '多选组',
        radio: '单选组',
        date: '日期',
        editor: 'iceEditor编辑器',
        slider: '滑块',
        image: '图片',
        grid: '一行多列',
        colorpicker: '颜色选择器',
        textarea: '多行文本',
        rate: '评分控件',
        switch: '开关',
        password: '密码框',
        carousel: '轮播',
        text: '显示文本',
        uploadUrl: '上传路径',
        expression: '验证',
        file: '文件',
        autoplay: '自动切换',
        anim: '切换方式',
        arrow: '切换箭头',
        tab: 'tab选项卡',
        tabHeaders: 'tab标题',
        isInput: '显示输入框',
        dateRange: '日期范围',
        dateRangeDefaultValue: '默认范围',
        menu: '头部菜单',
        numberInput: '数字输入框',
        iconPicker: '图标选择器',
        iconPickerSearch: '是否搜索',
        iconPickerPage: '是否分页',
        iconPickerLimit: '显示数量',
        iconPickerCellWidth: '图标宽度',
        cron: 'Cron表达式',
        cronUrl: '运行路径',
        labelGeneration: '标签组件',
        isEnter: '是否回车',
        buttonIcon: '按钮图标',
        buttonType: '按钮类型',
        isLabel: '显示标签',
        buttonSize: '组件尺寸',
        bottom: '按钮组件',
        buttonVlaue: '按钮文字',
        laySign: '签名组件',
        uploadImage: '图片上传',
        uploadFile: '文件上传',
        uploadVideo: '视频上传',
        uploadAudio: '音频上传',
        listShow: '列表显示',
        count: '总数'
    };
    var expressions = [
        {
            text: '默认',
            value: ''
        }, {
            text: '数字',
            value: 'number'
        }, {
            text: '邮箱',
            value: 'email'
        }, {
            text: '手机',
            value: 'phone'
        }, {
            text: '身份证',
            value: 'identity'
        }, {
            text: '日期',
            value: 'date'
        }, {
            text: '网址',
            value: 'url'
        }, {
            text: '密码',
            value: 'pass'
        }
    ];
    var anims = [
        {
            text: '左右切换',
            value: 'default'
        }, {
            text: '上下切换',
            value: 'updown'
        }, {
            text: '渐隐渐显切换',
            value: 'fade'
        }
    ];
    var arrows = [
        {
            text: '悬停显示',
            value: 'hover'
        }, {
            text: '始终显示',
            value: 'always'
        }, {
            text: '始终不显示',
            value: 'none'
        }
    ];
    var datetypes = [
        {
            text: '年选择器',
            value: 'year'
        }, {
            text: '年月选择器',
            value: 'month'
        }, {
            text: '时间选择器',
            value: 'time'
        }, {
            text: '日期选择器',
            value: 'date'
        }, {
            text: '日期时间选择器',
            value: 'datetime'
        }
    ];
    var buttonTypes = [
        {
            text: '原始',
            value: 'layui-btn-primary'
        }, {
            text: '默认',
            value: ''
        }, {
            text: '百搭',
            value: 'layui-btn-normal'
        }, {
            text: '暖色',
            value: 'layui-btn-warm'
        }, {
            text: '警告',
            value: ' layui-btn-danger'
        }
    ];
    var buttonSizes = [
        {
            text: '大型',
            value: 'layui-btn-lg'
        }, {
            text: '默认',
            value: ''
        }, {
            text: '小型',
            value: 'layui-btn-sm'
        }, {
            text: '迷你',
            value: 'layui-btn-xs'
        }
    ];
    var dateformats = ['yyyy年MM月', 'yyyy-MM-dd', 'dd/MM/yyyy', 'yyyyMMdd', 'yyyy-MM-dd HH:mm:ss', 'yyyy年MM月dd日 HH时mm分ss秒']
    var iceEditMenus = [
        {
            value: 'backColor',
            text: '字体背景颜色'
        }, {
            value: 'fontSize',
            text: '字体大小'
        }, {
            value: 'foreColor',
            text: '字体颜色'
        }, {
            value: 'bold',
            text: '粗体'
        }, {
            value: 'italic',
            text: '斜体'
        }, {
            value: 'underline',
            text: '下划线'
        }, {
            value: 'strikeThrough',
            text: '删除线'
        }, {
            value: 'justifyLeft',
            text: '左对齐'
        }, {
            value: 'justifyCenter',
            text: '居中对齐'
        }, {
            value: 'justifyRight',
            text: '右对齐'
        }, {
            value: 'indent',
            text: '增加缩进'
        }, {
            value: 'outdent',
            text: '减少缩进'
        }, {
            value: 'insertOrderedList',
            text: '有序列表'
        }, {
            value: 'insertUnorderedList',
            text: '无序列表'
        }, {
            value: 'superscript',
            text: '上标'
        }, {
            value: 'subscript',
            text: '下标'
        }, {
            value: 'createLink',
            text: '创建连接'
        }, {
            value: 'unlink',
            text: '取消连接'
        }, {
            value: 'hr',
            text: '水平线'
        }, {
            value: 'face',
            text: '表情'
        }, {
            value: 'table',
            text: '表格'
        }, {
            value: 'files',
            text: '附件'
        }, {
            value: 'music',
            text: '音乐'
        }, {
            value: 'video',
            text: '视频'
        }, {
            value: 'insertImage',
            text: '图片'
        }, {
            value: 'removeFormat',
            text: '格式化样式'
        }, {
            value: 'code',
            text: '源码'
        }, {
            value: 'line',
            text: '菜单分割线'
        }
    ];

    exports('consts', {
        lang: lang,
        expressions: expressions,
        anims: anims,
        arrows: arrows,
        datetypes: datetypes,
        buttonTypes: buttonTypes,
        buttonSizes: buttonSizes,
        dateformats: dateformats,
        iceEditMenus: iceEditMenus
    })
})