package ink.wgink.module.instantmessage.controller.route;

import ink.wgink.interfaces.consts.ISystemConstant;
import io.swagger.annotations.Api;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.servlet.ModelAndView;

/**
 * @ClassName: UnifiedMessagingRouteController
 * @Description: 统一消息统计可视化路由
 * @Author: wanggeng
 * @Date: 2021/10/24 3:30 下午
 * @Version: 1.0
 */
@Api(tags = ISystemConstant.ROUTE_TAGS_PREFIX + "webrtc")
@RestController
@RequestMapping(ISystemConstant.ROUTE_PREFIX + "/webrtc")
public class WebrtcRouteDemoController {

    @GetMapping("webrtc-one2one-demo")
    public ModelAndView report() {
        return new ModelAndView("webrtc-one2one-demo");
    }

}
