package ink.wgink.module.instantmessage.pojo.pos;

import java.io.Serializable;

/**
 * When you feel like quitting. Think about why you started
 * 当你想要放弃的时候，想想当初你为何开始
 *
 * @ClassName: NoticePO
 * @Description: 消息通知
 * @Author: wanggeng
 * @Date: 2021/3/29 4:39 下午
 * @Version: 1.0
 */
public class NoticePO implements Serializable {

    private static final long serialVersionUID = -7182904168489429255L;
    private Long id;
    private String noticeId;
    private String noticeTitle;
    private String noticeMsg;
    private String noticeTarget;
    private String noticeSystem;
    private String noticeModule;
    private String noticeMenu;
    private String noticeServiceId;
    private String userId;
    private String userName;
    private String userUsername;
    private Integer isSend;
    private Integer isHandle;
    private String gmtCreate;
    private String creator;
    private String gmtModified;
    private String modifier;
    private Integer isDelete;

    public Long getId() {
        return id == null ? 0 : id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getNoticeId() {
        return noticeId == null ? "" : noticeId;
    }

    public void setNoticeId(String noticeId) {
        this.noticeId = noticeId;
    }

    public String getNoticeTitle() {
        return noticeTitle == null ? "" : noticeTitle;
    }

    public void setNoticeTitle(String noticeTitle) {
        this.noticeTitle = noticeTitle;
    }

    public String getNoticeMsg() {
        return noticeMsg == null ? "" : noticeMsg;
    }

    public void setNoticeMsg(String noticeMsg) {
        this.noticeMsg = noticeMsg;
    }

    public String getNoticeTarget() {
        return noticeTarget == null ? "" : noticeTarget;
    }

    public void setNoticeTarget(String noticeTarget) {
        this.noticeTarget = noticeTarget;
    }

    public String getNoticeSystem() {
        return noticeSystem == null ? "" : noticeSystem;
    }

    public void setNoticeSystem(String noticeSystem) {
        this.noticeSystem = noticeSystem;
    }

    public String getNoticeModule() {
        return noticeModule == null ? "" : noticeModule;
    }

    public void setNoticeModule(String noticeModule) {
        this.noticeModule = noticeModule;
    }

    public String getNoticeMenu() {
        return noticeMenu == null ? "" : noticeMenu;
    }

    public void setNoticeMenu(String noticeMenu) {
        this.noticeMenu = noticeMenu;
    }

    public String getNoticeServiceId() {
        return noticeServiceId == null ? "" : noticeServiceId;
    }

    public void setNoticeServiceId(String noticeServiceId) {
        this.noticeServiceId = noticeServiceId;
    }

    public String getUserId() {
        return userId == null ? "" : userId;
    }

    public void setUserId(String userId) {
        this.userId = userId;
    }

    public String getUserName() {
        return userName == null ? "" : userName.trim();
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public String getUserUsername() {
        return userUsername == null ? "" : userUsername.trim();
    }

    public void setUserUsername(String userUsername) {
        this.userUsername = userUsername;
    }

    public Integer getIsSend() {
        return isSend == null ? 0 : isSend;
    }

    public void setIsSend(Integer isSend) {
        this.isSend = isSend;
    }

    public Integer getIsHandle() {
        return isHandle == null ? 0 : isHandle;
    }

    public void setIsHandle(Integer isHandle) {
        this.isHandle = isHandle;
    }

    public String getGmtCreate() {
        return gmtCreate == null ? "" : gmtCreate;
    }

    public void setGmtCreate(String gmtCreate) {
        this.gmtCreate = gmtCreate;
    }

    public String getCreator() {
        return creator == null ? "" : creator;
    }

    public void setCreator(String creator) {
        this.creator = creator;
    }

    public String getGmtModified() {
        return gmtModified == null ? "" : gmtModified;
    }

    public void setGmtModified(String gmtModified) {
        this.gmtModified = gmtModified;
    }

    public String getModifier() {
        return modifier == null ? "" : modifier;
    }

    public void setModifier(String modifier) {
        this.modifier = modifier;
    }

    public Integer getIsDelete() {
        return isDelete == null ? 0 : isDelete;
    }

    public void setIsDelete(Integer isDelete) {
        this.isDelete = isDelete;
    }


}
